# Class PMGClass

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.PMGClass

All Implemented Interfaces:
  `Cloneable, Node`

public final class PMGClass extends Attribute
This class is derived from Attribute and represents a reference to a PMG attribute.

See Also:
  - `Attribute`

- ## Field Summary

  ### Fields inherited from class Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PMGClass(int nameIndex, int length, int pmgIndex, int pmgClassIndex, ConstantPool constantPool)`
  `PMGClass(PMGClass pgmClass)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `Attribute`
  `copy(ConstantPool constantPool)`
  Creates a deep copy of this attribute.
  `void`
  `dump(DataOutputStream file)`
  Dumps source file attribute to file stream in binary format.
  `int`
  `getPMGClassIndex()`
  `String`
  `getPMGClassName()`
  `int`
  `getPMGIndex()`
  `String`
  `getPMGName()`
  `void`
  `setPMGClassIndex(int pmgClassIndex)`
  `void`
  `setPMGIndex(int pmgIndex)`
  `String`
  `toString()`

  ### Methods inherited from class Attribute

  `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### PMGClass

    public PMGClass(int nameIndex, int length, int pmgIndex, int pmgClassIndex, ConstantPool constantPool)
    Parameters:
      `nameIndex` - Index in constant pool to CONSTANT_Utf8.
      `length` - Content length in bytes.
      `pmgIndex` - index in constant pool for source file name.
      `pmgClassIndex` - Index in constant pool to CONSTANT_Utf8.
      `constantPool` - Array of constants.

  - ### PMGClass

    public PMGClass(PMGClass pgmClass)
    Initialize from another object. Note that both objects use the same references (shallow copy). Use copy() for a physical copy.
    Parameters:
      `pgmClass` - Source to copy.

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object.

  - ### copy

    public Attribute copy(ConstantPool constantPool)
    Description copied from class: `Attribute`
    Creates a deep copy of this attribute.
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute.

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dumps source file attribute to file stream in binary format.
    Overrides:
      `dump` in class `Attribute`
    Parameters:
      `file` - Output file stream.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getPMGClassIndex

    public int getPMGClassIndex()
    Returns:
      Index in constant pool of source file name.

  - ### getPMGClassName

    public String getPMGClassName()
    Returns:
      PMG class name.

  - ### getPMGIndex

    public int getPMGIndex()
    Returns:
      Index in constant pool of source file name.

  - ### getPMGName

    public String getPMGName()
    Returns:
      PMG name.

  - ### setPMGClassIndex

    public void setPMGClassIndex(int pmgClassIndex)
    Parameters:
      `pmgClassIndex` - The class index.

  - ### setPMGIndex

    public void setPMGIndex(int pmgIndex)
    Parameters:
      `pmgIndex` - The index.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      String representation.